/*
 * Copyright (c) 1992 Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the University of California, Lawrence Berkeley Laboratory,
 * Berkeley, CA.  The name of the University may not be used to
 * endorse or promote products derived from this software without
 * specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

#ifndef lint
static char rcsid[] =
    "@(#) $Header: /usr/src/mash/repository/mash/mash-1/ps/ps.cc,v 1.4 1997/08/09 03:58:20 tecklee Exp $ (LBL)";
#endif

#ifndef WIN32
#   include <osfcn.h>
#else
#   include "config.h"
#   include <windows.h>
#   include <io.h>
#endif
#include <errno.h>
#include <fcntl.h>
#include <stdio.h>
#include <string.h>

#include "tclcl.h"
#include "ps.h"

/*XXX*/
const char* wbpssrvrloop = "\
userdict /$brkpage {} put\n\
userdict /_$wb$save save put\n\
(%s)(r)file cvx stopped pop\n\
grestoreall clear cleardictstack _$wb$save restore _$wb$showpage\n\
";

PSinterp::PSinterp()
{
	char t[512];

	raster_ = 0;
	strm_ = 0;
	op_ = 0;
	view_ = 0;
#ifdef notdef
	const char* tmpdir = Tcl::instance().attr("tmpdir");
#endif
	/*XXX*/
	const char* tmpdir = "/tmp";
	sprintf(t, "%s/.wb_%d_.ps", tmpdir, getpid());
	tmpfile_ = strdup(t);
	tmpfd_ = open(tmpfile_, O_WRONLY|O_CREAT, 0666);
	if (tmpfd_ == -1) {
		perror(tmpfile_);
		exit(1);
	}
}

PSinterp::~PSinterp()
{
	close(tmpfd_);
	unlink(tmpfile_);
}

int PSinterp::busy()
{
	return (0);
}

int PSinterp::send(DrawOpPSComp* o, View* v, PSstream* s)
{
	return (1);
}

void PSinterp::interp_done(Window mwin)
{
}

void PSinterp::interp_page(Window mwin)
{
}
