#
# Copyright (c) 1998 Regents of the University of California.
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
# 3. All advertising materials mentioning features or use of this software
#    must display the following acknowledgement:
# 	This product includes software developed by the MASH Research
# 	Group at the University of California Berkeley.
# 4. Neither the name of the University nor of the Research Group may be
#    used to endorse or promote products derived from this software without
#    specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# @(#) $Header: /usr/src/mash/repository/mash/mash-1/tcl/caster/main.tcl,v 1.8 1998/01/10 01:42:57 mccanne Exp $
#
import Application CastingDirectorServer CastingProxy ArchiveSystem \
	AnnounceListenManager

#
# Create a server to listen for http requests on the applet
# bootstrap port.  This simple server reponds only
# to GETs of "RemoteController.class" and "applet.html"
#

set server [new TCP/Server]
#XXX port from caster module
$server open $castingDirectorProxyPort CastingProxy


set app [new Application caster]
set server [new CastingDirectorServer $castingDirectorPort]

set f [font create -family helvetica -size 10 -weight bold]

label .l -text "MASH Casting Director" -relief raised
button .b -text "quit" -command exit -font $f

label .s -text "Status: " -relief raised

pack .l .s .b

if {$tcl_platform(platform)=="windows"} {
        if [info exists env(TEMP)] {
                set archive $env(TEMP)
        } elseif [info exists env(TMP)] {
                set archive $env(TMP)
        } else {
                set archive "/"
        }
} else {
        set archive /var/tmp
}
set module mashdemo
set dir $archive/$module
file mkdir $dir

.l configure -text "fetching archived data via http..." -width 40

#XXX get tcl http stuff
import ProxyConnection

CastingDirector instproc user_hook {} {
	#XXX

	.s configure -text "Status: connected to browser"
	new CasterNet $self

	return

	global as
	$self set urls_ {
		{ 5 http://www.cs.berkeley.edu/~mccanne/ }
		{ 50 http://www-mash.cs.berkeley.edu/mash/ }
		{ 62 http://www-mash.cs.berkeley.edu/mash/news.html }
	}
	$self set curl_ 0
	$self sched_next

	$as at 95.0 exit

	global cd
	set cd $self

#	after 1000 foo
}

proc foo {} {
	global as
	set lts [$as set lts_]
	set start [$as set start_]
	puts stderr "[expr [$lts now_logical] - $start]"
	after 1000 foo
}

CastingDirector instproc sched_next {} {
	$self instvar urls_ curl_
	if { $curl_ < [llength $urls_] } {
		set r [lindex $urls_ $curl_]
		global as
		$as at [lindex $r 0] "$self show [lindex $r 1]"
XXX
		$self instvar curl_
		incr curl_
		$self sched_next
	}
}

CastingDirector instproc show url {
	$self sendline "show: $url"
}

#
# from the tcl http man page
#
proc ::http::copy { url file {chunk 4096} } {
    set out [open $file w]
    fconfigure $out -translation binary
    set token [geturl $url -channel $out -progress ::http::Progress \
	    -blocksize $chunk]
    close $out
    # This ends the line started by http::Progress
    puts stderr ""
    upvar #0 $token state
    set max 0
    foreach {name value} $state(meta) {
	if {[string length $name] > $max} {
	    set max [string length $name]
	}
	if {[regexp -nocase ^location$ $name]} {
	    # Handle URL redirects
	    puts stderr "Location:$value"
	    return [copy [string trim $value] $file $chunk]
	}
    }
    incr max
    foreach {name value} $state(meta) {
	puts [format "%-*s %s" $max $name: $value]
    }
    return $token
}
proc ::http::Progress {args} {
    puts -nonewline stderr . ; flush stderr
}

#foreach name {
#	catalog
#	video_video-video6-1.dat
#	video_video-video6-1.idx
#	audio_audio-audio6-1.dat
#	audio_audio-audio6-1.idx
#} {
#	#XXX not the best way to do this...
#	.l configure -text "fetching $name..."
#	set path http://www-mash.cs.berkeley.edu/dist/mccanne/demo1
#	set url $path/$name

#	::http::copy $url $dir/$name

	#XXX
#	update
#}

.l configure -text "MASH Casting Director"

set aspec 224.2.3.4/9822
set vspec 224.2.3.5/9832

Class PlaybackApp -superclass Application

PlaybackApp public init { aspec vspec } {
	global archive module as
	$self next demo-play
	$self add_option loopback 1
	set as [new ArchiveSystem/Play]
	$as open $archive $module
	$as play_session $vspec video
	$as play_session $aspec audio
	$as start
}

#new PlaybackApp $aspec $vspec

Class CasterNet -superclass AnnounceListenManager 

#XXX by default we are recv-only
CasterNet public init { director } {
	$self next 1000 224.2.3.87/10320/16
	$self instvar director_
	set director_ $director
}

CasterNet public recv_announcement { src msg len } {
	$self instvar director_
	$director_ show $msg
}
