#
# Copyright (c) @ Regents of the University of California.
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
# 3. All advertising materials mentioning features or use of this software
#    must display the following acknowledgement:
# 	This product includes software developed by the MASH Research
# 	Group at the University of California Berkeley.
# 4. Neither the name of the University nor of the Research Group may be
#    used to endorse or promote products derived from this software without
#    specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# @(#) $Header: /usr/src/mash/repository/mash/mash-1/tcl/mgamon/al-asmon.tcl,v 1.2 1998/09/10 04:16:36 yatin Exp $
#

import AnnounceListenManager/AS
 
Class AnnounceListenManager/AS/ASMon -superclass AnnounceListenManager/AS

AnnounceListenManager/AS/ASMon instproc init { agent spec bw } {
	$self next $spec $bw mgamon
	$self instvar agent_
	set agent_ $agent
}

AnnounceListenManager/AS/ASMon instproc build_announcement {} {
	puts stderr "AS Monitor build_announcement called!"
	return ""
}

AnnounceListenManager/AS/ASMon instproc recv_msg { atype aspec addr srv_name\
		srv_loc srv_inst ssg_port agent_data } {
	$self instvar agent_ avgdelta_
	if { $srv_name == "DEATH" } {
		return
	}

	if { $atype=="hm" } { set srv_name "" }
	$agent_ recv_msg $atype $aspec $addr $srv_name $srv_loc $srv_inst\
			$ssg_port $agent_data $avgdelta_($aspec)
}


AnnounceListenManager/AS/ASMon instproc register { atype aspec addr srv_name \
		srv_inst agent_data } {
	$self instvar agent_
	if { $atype=="hm" } { set srv_name "" }
	$agent_ register $atype $aspec $addr $srv_name $srv_inst $agent_data
}

AnnounceListenManager/AS/ASMon instproc unregister { atype aspec addr srv_name\
		srv_inst agent_data } {
	$self instvar agent_
	if { $atype=="hm" } { set srv_name "" }
	$agent_ unregister $atype $aspec $addr $srv_name $srv_inst $agent_data
}
