#
# Copyright (c) 1993-1995 Regents of the University of California.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
# 3. All advertising materials mentioning features or use of this software
#    must display the following acknowledgement:
#	This product includes software developed by the Network Research
#	Group at Lawrence Berkeley National Laboratory.
# 4. Neither the name of the University nor of the Laboratory may be used
#    to endorse or promote products derived from this software without
#    specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# @(#) $Header: /usr/src/mash/repository/mash/mash-1/tcl/rvic/ui-remote.tcl,v 1.18 1998/08/21 20:04:12 hodes Exp $ (LBL)
#

# rvic is broken and needs work
#
#   Todd Hodes


import RTPAgent VisualFrame 

#
# Make an agent that monitors RTP audio activity
#
Class AudioMonitor/Rvic -superclass RTPAgent

#XXX
AudioMonitor/Rvic private create_session {} {
	return [new Session/RTP/Audio]
}

#
AudioMonitor/Rvic instproc init { ab ui } {
	$self next $ab
	$self set ui_ $ui
}

#
AudioMonitor/Rvic instproc activate src {
	$self instvar null_
	if ![info exists null_] {
		set null_ [new Module/AudioDecoder]
	}
	$src handler $null_
	$self next $src
#	puts "activate [$src getid]"
}

#
AudioMonitor/Rvic instproc trigger_media src {
	#XXX race: if src disappears will get an undefined command
	after 500 "$src enable_trigger"
	$self next $src
	$self instvar ui_
	
	$ui_ switch_to $src
}

#
AudioMonitor/Rvic instproc create-session sessionType {
	if { $sessionType == "rtpv2" || $sessionType == "rtp" } {
		set sessionType RTP
	}
	return [new Session/$sessionType/Audio]
}


#
# pulled out of HeadlessVic - SimpleSource has no cmenu, useHW
# hard-coded to 0.
#
Class SimpleSource/Rvic
SimpleSource/Rvic instproc init { parent src } {
	$self next
	$self instvar src_ parent_
	set src_ $src
	set parent_ $parent
}

#
# bind a source to a window so that the video stream from
# source $src appears in window $vw, which is a UserWindow
#
SimpleSource/Rvic instproc attach-window vw {
	$self instvar src_ parent_
	# hard-coded useHW to 0!
	$vw attach-decoder $src_ [[$parent_ set vframe_] set colorModel_] 0
}

#
SimpleSource/Rvic instproc detach-window vw {
	$self instvar src_
	$vw detach-decoder $src_
}


#
# XXX Added this to try to allow "decativate" method work
#
SimpleSource/Rvic instproc user-windows {} {
	puts "user-windows called"
	#    return [$self set userwindows_]	
    return ""
}

#
# XXX null call for now
#
SimpleSource/Rvic instproc detach-windows {} {
	puts "detach-windows called: $self"
	$self instvar parent_
	set the_ui $parent_

	$self instvar window_ attached_src_

	set srcsList [$the_ui set allsrcs_]
	
	set goner [lsearch $srcsList $self]
	if {$goner != -1} {
		$the_ui set allsrcs_ [lreplace $srcsList $goner $goner]
	}

    return
}



import VicUI

#
# The main user interface for the rvic application.
#
Class RemoteVicUI -superclass VicUI

#
# Build the "user-interface."
#
RemoteVicUI instproc build_gui { w } {

	$self instvar videoAgent_ userwindows_ grid_ label_ controlMenu_ path_ vpipe_ vframe_ 
			
	foreach i {"" 2 3 4 5 6 7 8 9} {
		$self instvar window${i}_
	}

	set path_ $w

	global the_ui
	set the_ui $self

	set vframe_ [new VisualFrame $w.top $self]
	$self set allsrcs_ ""

	wm geometry . 640x480+0+0
	# after 5000 puts "[wm geometry .]"  # XXX  doesn't work!?
	place $w.top -x -5 -y -5 -width 640 -height 480
	label $w.top.l -text "Waiting to finish configuring video windows..."
	place $w.top.l -relx 0.5 -rely 0.5 -anchor c
	after 3000 "$self reconfig FocusPlusContext"
	after 3000 "wm title . {rvic: [localaddr]}"
	after 5000 "$self set-default-vw-views"

	set p $w.top.vw
	#XXX
	set window_ [new VideoWidget $p 640 480]
	#place $w.top.vw -relx 0.0 -rely 0.0
	bind all <Key-1> "$self switch_src_by_num 1"
	bind $p <s> "$self switch_src_by_num_name 1 {}"
    bind $p <a> "$self current-source 1"

	bind . <a> "$self active-sources"
	bind . <q> "exit 1"
	foreach {key configname} {y FocusPlusContext u Single i BradyBunch2x2 
			o BradyBunch3x3 p PictureInPicture} {	
		bind . <$key> "$self reconfig $configname"
	}
	foreach i {2 3 4 5 6 7 8 9} {
		bind all <Key-$i> "$self switch_src_by_num $i"
		set p $w.top.vw$i
		set window${i}_ [new VideoWidget $p 320 240]
		#place $w.top.vw$i -relx 0.$i -rely 0.$i
		bind $p <s> "$self switch_src_by_num_name $i {}"
		bind $p <a> "$self current-source $i"
	}

	# XXX sending {} for the ActiveSourceManager parameter, which will likely only cause problems if you try to redecorate using build.tile
	set controlMenu_ [new ControlMenu $self $videoAgent_ $vpipe_ $vframe_ {} [new UISrcListWindow $w $videoAgent_]]
        
	# MASH/Dae
	set aspec 224.2.204.152/25970
	#XXX
	puts stderr "warning audio-mon address hardwired to: $aspec"

	if { $aspec != "" } {
		set ab [new AddressBlock $aspec]
		set monitor [new AudioMonitor/Rvic $ab $self]
		# audio doesn't want traffic looped back
		#$audioAgent_ set-loopback 0
		# send back-to-back packets spaced out at 128kb/s
		#$audioAgent_ set-bandwidth 128
	}
	after 1000 "$self periodic_update"
}

# Set up video widgets so that as many sources as possible are shown
# (a so-called "default view")
#
RemoteVicUI instproc set-default-vw-views {args} {
	$self instvar active_ allsrcs_

	set nameList $allsrcs_
	set l [llength $nameList]

	if {$l == 0} {
		after 5000 "$self set-default-vw-views $args"
		return
	}
	
	foreach i {0 1 2 3 4 5 6 7} {
		set idx [expr $i % $l]
		set s [lindex $nameList $idx]
		$self switch_src_by_num_name [expr $i + 2] [$s getid]
	}	
}

#
RemoteVicUI instproc switch_src_by_num_name {int name} {
	$self instvar allsrcs_ active_
	foreach i {"" 2 3 4 5 6 7 8 9} {
		$self instvar window${i}_ attached_src${i}_
	}

	puts "trying to switch $int to $name"

	if { [llength $allsrcs_] > 0 } {
		if {$name == ""} {
			$self switch_src_by_num $int 
			return
		}
		set target ""
		foreach s [array names active_] {
			#puts "$name ?=? [$s getid]"
			if {[string first $name [$s getid]] != -1} {
				set target $s				
			}
		}
		if { $target == "" } {
			foreach s [array names active_] {
				if {[string first $name [$s sdes cname]] != -1} {
					set target $s				
				}
			}
		}
		if { $target == "" } {
			foreach s [array names active_] {
				if {[string first $name [$s sdes name]] != -1} {
					set target $s				
				}
			}
		}
		if { $target == "" } {
			foreach s [array names active_] {
				if {[string first $name [$s sdes note]] != -1} {
					set target $s				
				}
			}
		}
		if { $target == "" } {
			puts stderr "no target - \"$name\""
			if {[llength $name] > 1} {
				puts "trying [lindex $name 0]"
				if {[regexp -nocase [lindex $name 0] [$s getid]]} {
					set target $s				
				}   
			}
			if { $target == "" } {
				$self switch_src_by_num $int
				return
			}
		}	
		if {$int == 1} {
			set cnt ""
		} else {
			set cnt $int
		}
		puts "switching to [$target getid]"
		set olds $active_([set attached_src${cnt}_])
		$olds detach-window [set window${cnt}_]
		set as $active_($target)
		$as attach-window [set window${cnt}_]
		set attached_src${cnt}_ $target
		[set window${cnt}_] redraw
	}
}

#
RemoteVicUI instproc switch_src_by_num {num} {
	$self instvar allsrcs_ active_
	foreach i {"" 2 3 4 5 6 7 8 9} {
		$self instvar window${i}_ attached_src${i}_
	}

	#puts "num sources = [llength $allsrcs_]"
	set len [llength $allsrcs_]
	if { $len > 0 } {
		if {$num == 1} {
			set cnt ""
		} else {
			set cnt $num
		}
		set j [lsearch $allsrcs_ [set attached_src${cnt}_]]
		set j [expr ($j+1) % $len]
		set olds $active_([set attached_src${cnt}_])
		$olds detach-window [set window${cnt}_]
		set src [lindex $allsrcs_ $j]
		set as $active_($src)
		$as attach-window [set window${cnt}_]
		set attached_src${cnt}_ $src
		[set window${cnt}_] redraw
	}
}

#
RemoteVicUI instproc switch_src {} {
	$self instvar allsrcs_ active_
	foreach i {"" 2 3 4 5 6 7 8 9} {
		$self instvar window${i}_ attached_src${i}_
	}

	if { [llength $allsrcs_] > 0 } {
		set len [llength $allsrcs_]
		foreach cnt {"" 2 3 4 5 6 7 8 9} {
			set j [lsearch $allsrcs_ [set attached_src${cnt}_]]
			set j [expr ($j+1) % $len]
			set olds $active_([set attached_src${cnt}_])
			$olds detach-window [set window${cnt}_]
			set src [lindex $allsrcs_ $j]
			set as $active_($src)
			$as attach-window [set window${cnt}_]
			set attached_src${cnt}_ $src
			[set window${cnt}_] redraw
		}
	}
}

#
# <i>src</i> is an audio src. <br>
# <i>allsrcs_</i> are video sources
# <br>
# XXX * Only deals with window_ * XXX
#
RemoteVicUI instproc switch_to src {
	$self instvar allsrcs_ attached_src_ window_ active_
	if { [string match *CoLab* [$src getid]] } {
		return
	}
	if { [llength $allsrcs_] > 0 } {
		set target ""
		foreach s $allsrcs_ {
			if { "[$src sdes cname]" == "[$s sdes cname]" } {
				set target $s
			}
		}
		if { $target == "" } {
			puts stderr "no target - [$src sdes cname]"
			return
		}
puts "switch to [$target getid]"
		set olds $active_($attached_src_)
		$olds detach-window $window_
		set as $active_($target)
		$as attach-window $window_
		set attached_src_ $target
		$window_ redraw
	}
}

#
# Return a list of the active sources.
#
RemoteVicUI instproc active-sources {} {
	$self instvar active_

        # The getid calls break sometimes? ... XXX
	#foreach i [array names active_] {
	#	puts "$i: [$i getid]"
	#}
	return [array names active_]
}

#
RemoteVicUI instproc active-source {int} {
	$self instvar active_ window${int}_ attached_src${int}_

    # This breaks!
    #puts "[$attached_src${int}_ getid]"
}

#
# Add the ActiveSource, <i>as</i>, to the <i>active_</i> array (indexed by Source, <i>src</i>).
# Also add the Source to the list, <i>allsrcs_</i>.
#
RemoteVicUI instproc add_active { as src } {
	$self instvar active_ allsrcs_
	set active_($src) $as
	lappend allsrcs_ $src
}

#
# Remove the Source, <i>src</i>, from the <i>active_</i> array and the <i>allsrcs_</i> list.
#
RemoteVicUI instproc rm_active src {
	$self instvar active_ allsrcs_
	unset active_($src)
	set i [lsearch $allsrcs_ $src]
	set allsrcs_ [lreplace allsrcs_ $i $i]
}

#
# Update the source descprtion by updating the element of the global
# arrays src_info(), src_nickname(), and src_name() indexed by the
# specified <i>src</i>.  If the src_name() is changed, then this is
# reflected in the UserWindows in which this src appears.
#
RemoteVicUI instproc trigger_sdes src {
	#XXX
	return
	
	global src_info src_nickname src_name
	#
	# Figure out best presentation from available information.
	#
	set name [$src sdes name]
	set cname [$src sdes cname]
	set addr [$src addr]
	if { $name == "" } {
		if { $cname == "" } {
			set src_nickname($src) $addr
			set info $addr/[$src format_name]

		} else {
			set src_nickname($src) $cname
			set info "$addr/[$src format_name]"
		}
	} elseif [cname_redundant $name $cname] {
		set src_nickname($src) $name
		set info $addr/[$src format_name]
	} else {
		set src_nickname($src) $name
		set info $cname/[$src format_name]
	}
		set src_info($src) $cname/[$src format_name]

	set msg [$src sdes note]
	if { $msg != "" } {
		set info $msg
	}
	set src_info($src) $info
	
	# only call change_name when name really changes
	if { ![info exists src_name($src)] || "$src_name($src)" != "$name" } {
		set src_name($src) $name
		# XXX this will no longer work, because RemoteVicUI does not implement "change_name"
		#  It is now implemented by ActiveSourceManager, which rvic doesn't even use.
#		$self change_name $src
	}
}

# nop
RemoteVicUI instproc trigger_media src {}

#
# Add a src to the active senders list.  E.g., make a postage
# stamp window appear, stats, etc. so that the user can select
# the video stream.
#
RemoteVicUI instproc activate src {
	#
	# give the VideoAgent a chance to create and install
	# a decoder and for that decoder to see a packet so it can
	# determine the output geometry and color decimation.
	# we shouldn't have to do this (e.g., resize will
	# take care of a geometry change), but currently
	# decoders can't trigger a renderer realloation
	# when the decimation changes.XXX fix this
	#
	after idle "$self really_activate $src"
}

#
RemoteVicUI instproc really_activate src {
	set as [new SimpleSource/Rvic $self $src]
	$self add_active $as $src
	$self instvar allsrcs_ active_
	foreach i {"" 2 3 4 5 6 7 8 9} {
		$self instvar window${i}_ attached_src${i}_
	}
	#XXX only if empty
	foreach i {"" 2 3 4 5 6 7 8 9} {
		if ![info exists attached_src${i}_] {
			set tmpWinName window${i}_
			eval $as attach-window $[set tmpWinName]
			set attached_src${i}_ $src
		}
	}
}

puts "this code not right yet"

#
RemoteVicUI instproc trigger_format src {
	$self instvar active_ videoAgent_ window_
	if ![info exists active_($src)] {
		#
		# if we get a change format before really_activate
		# was called (i.e., so we don't even have a thumbnail yet),
		# don't do anything
		#
		return
	}
	set as $active_($src)
	$as detach-window $window_
	set d [$src handler]
	delete $d
	set d [$videoAgent_ create_decoder $src]
	$as attach-window $window_
	$window_ redraw
}

#
# Called when the video stream state changes in a way that would
# affect the choice of renderer.  For example, when a jpeg stream
# changes from type-0 to type-1 we might have to revert from
# hardware to software decoding, or we might have to reallocate
# a 422 renderer as a 411 renderer.  This never needs to happen
# for most stream types (i.e., because the decimation factor is fixed).
#
RemoteVicUI instproc decoder_changed src {
	$self instvar active_
	if ![info exists active_($src)] {
		return
	}
	#XXX redundant with trigger_format
	set as $active_($src)

	set L [$as user-windows]
	$as detach-windows
	#XXX
	set extoutList [extout_detach_src $src]
	foreach w $iw {
		$as attach-window $uw
		$w redraw
	}
	#XXX
	extout_attach_src $src $extoutList
	return
}

#
# Remove a src from the active senders list. 
#
RemoteVicUI instproc deactivate src {
	$self instvar active_
	if [info exists active_($src)] {
		set as $active_($src)
		#set L [$as user-windows]
		#foreach uw $L {
		#	#XXX should check if we're voice-switched
		#	# and if so, bump window
		#	delete $uw
		#}
		# detach any we missed by deleting user-windows
		$as detach-windows
	}

	$src handler ""
}

import AnnounceListenManager UDPChannel

#
# The remote-control interface to RVIC
#
Class AnnounceListenManager/Rvic -superclass AnnounceListenManager


#
# what to do on receipt of announcement: simply routes to an RVIC procedure
#
AnnounceListenManager/Rvic instproc recv_announcement {addr port data size} {
    puts "Msg: $addr/$port\[$size\]: $data"
	global the_ui

	# XXX the MASH net send object is broken with regards to 
	# XXX ephemeral ports -- use server well-known port for now
	set port [lindex [split [$self get_option rvicCtrlSpec] /] 1]

	if {[string first "Get" $data] == 0} {
		$the_ui HandleGet $addr/$port $data
	} elseif {[string first "Set" $data] == 0} {
		$the_ui HandleSet $addr/$port $data
	} else {
		set replyData "Message unimplemented: $data"
		puts $replyData
		set tmpSender [new UDPChannel $addr/$port] 
		$tmpSender send $replyData
		delete $tmpSender
	}
}

#
RemoteVicUI instproc HandleGet {addrport data} {

	if {[string first "Get SourceList" $data] != -1} {
		set reply "SourceList"
		foreach i [$self active-sources] {
			append reply "\n" [$i getid]
		}
		set tmpSender [new UDPChannel $addrport] 
		$tmpSender send $reply
		delete $tmpSender

	} elseif {[string first "Get MonitorStyle" $data] != -1} {
		set replyData "MonitorStyleList\n\
				Single {0.0+0.0+1.0x1.0}\n\
				BradyBunch2x2 {0.0+0.0+0.5x0.5 \
				0.5+0.0+0.5x0.5 \
				0.0+0.5+0.5x0.5 \
				0.5+0.5+0.5x0.5}\n\
				BradyBunch3x3 {0.0625+0.0625+0.25x0.25 \
				0.375+0.0625+0.25x0.25 \
				0.6875+0.0625+0.25x0.25 \
				0.0625+0.375+0.25x0.25 \
				0.375+0.375+0.25x0.25 \
				0.6875+0.375+0.25x0.25 \
				0.0625+0.6875+0.25x0.25 \
				0.375+0.6875+0.25x0.25 \
				0.6875+0.6875+0.25x0.25}\n\
				FocusPlusContext {0.09375+0.09375+0.5x0.5 \
				0.6875+0.0625+0.25x0.25 \
				0.6875+0.3750+0.25x0.25 \
				0.0625+0.6875+0.25x0.25 \
				0.3750+0.6875+0.25x0.25 \
				0.6875+0.6875+0.25x0.25}\n\
				PictureInPicture {0.0+0.0+1.0x1.0 \
				0.7+0.05+0.25x0.25}"
		set tmpSender [new UDPChannel $addrport] 
		$tmpSender send $replyData
		delete $tmpSender
	}
}

#
RemoteVicUI instproc HandleSet {addrport data} {
	$self instvar currLayout_ 

	puts "$data"
	if {[string first "Set MonitorStyle" $data] != -1} {
		if {[lrange $data 2 end] == ""} {
			set tmpSender [new UDPChannel $addrport] 
			$tmpSender send "MonitorStyle $currLayout_"
			delete $tmpSender
		} else {
			$self reconfig [lrange $data 2 end]
		}
	} elseif {[string first "Set VideoWindow" $data] != -1} {
		if {[llength $data] > 3} {
			$self switch_src_by_num_name [lindex $data 2] \
					[lrange $data 3 end]
		} elseif {[llength $data] == 3} {
			if {[regexp -nocase "all" [lindex $data 2]]} {
				$self switch_src
			} else {
				$self switch_src_by_num [lindex $data 2]
			}
		} else {
			# blank argument: return update of vw-->cname mapping
			set reply "Set VideoWindow"
			set counter 1
			foreach i {"" 2 3 4 5 6 7 8 9} {
				$self instvar attached_src${i}_
				append reply "\n$counter " [[set attached_src${i}_] getid]
				incr counter
			}
			set tmpSender [new UDPChannel $addrport] 
			$tmpSender send $reply
			delete $tmpSender
		}
	}
}

#
# This reconfigures the video windows. <i>args</i> can be
# "FocusPlusContext", "Single", "BradyBunch2x2", "BradyBunch3x3", 
# "PictureInPicture".
#
RemoteVicUI instproc reconfig {args} {
	$self instvar currLayout_ allsrcs_ active_ path_
	foreach i {"" 2 3 4 5 6 7 8 9} {
		$self instvar window${i}_ attached_src${i}_
	}

	# check for no sources
	if {[llength $allsrcs_] == 0} {
		if {[info commands $path_.top.l] == ""} {
			label $path_.top.l -text "Waiting for video..."
			place $path_.top.l -relx 0.5 -rely 0.5 -anchor c
		} else {
			$path_.top.l configure -text "Waiting for video..."
			after 6000 $self reconfig FocusPlusContext
		}
		return
	} else {
		destroy $path_.top.l
	}

	set w $path_

	if {($args == "FocusPlusContext")} {
		# XXX code not right!
		# default configuration
		[$window_ window] resize 320 240
		place configure $w.top.vw -relx 0.09375 -rely 0.09375 -x 0 -y 0
		set as $active_($attached_src_)
		$as detach-window $window_
		$as attach-window $window_
		$window_ redraw
		after 1000 $window_ redraw

		foreach i {2 3 4 5 6 7 8 9} {
			set wind [set window${i}_]
			if {$i > 6} {
				[[set window${i}_] window] resize 1 1
			} else {
				[[set window${i}_] window] resize 160 120
			}
			switch $i {
				2 {place configure $w.top.vw$i -relx 0.6875 -rely 0.0625 \
					-x 0 -y 0}
				3 {place configure $w.top.vw$i -relx 0.6875 -rely 0.3750 \
					-x 0 -y 0}
				4 {place configure $w.top.vw$i -relx 0.0625 -rely 0.6875 \
					-x 0 -y 0}
				5 {place configure $w.top.vw$i -relx 0.3750 -rely 0.6875 \
					-x 0 -y 0}
				6 {place configure $w.top.vw$i -relx 0.6875 -rely 0.6875 \
					-x 0 -y 0}
			}
			set as $active_([set attached_src${i}_])
			$as detach-window $wind
			$as attach-window $wind
			$wind redraw
			after 1000 $wind redraw
		}
	} elseif {$args == "Single"} {
		[$window_ window] resize 640 480
		place configure $w.top.vw -relx 0.0 -rely 0.0 -x 0 -y 0
		set as $active_($attached_src_)
		$as detach-window $window_
		$as attach-window $window_
		$window_ redraw
		after 1000 $window_ redraw
		foreach i {2 3 4 5 6 7 8 9} {
			set wind [set window${i}_]
			[$wind window] resize 1 1
			set as $active_([set attached_src${i}_])
			$as detach-window $wind
			$as attach-window $wind
			$window_ redraw
			after 1000 $wind redraw			
		}
	} elseif {$args == "BradyBunch2x2"} {
		[$window_ window] resize 320 240
		place configure $w.top.vw -relx 0.0 -rely 0.0 -x 0 -y 0
		set as $active_($attached_src_)
		$as detach-window $window_
		$as attach-window $window_
		$window_ redraw
		after 1000 $window_ redraw
		
		foreach i {2 3 4 5 6 7 8 9} {
			set wind [set window${i}_]
			if {$i > 4} {
				[$wind window] resize 1 1
			} else {
				[$wind window] resize 320 240
			}
			switch $i {
				2 {place configure $w.top.vw$i -relx 0.5 -rely 0.0 -x 4 -y 0}
				3 {place configure $w.top.vw$i -relx 0.0 -rely 0.5 -x 0 -y 4}
				4 {place configure $w.top.vw$i -relx 0.5 -rely 0.5 -x 4 -y 4}
			}
			set as $active_([set attached_src${i}_])
			$as detach-window $wind
			$as attach-window $wind
			$wind redraw
			after 1000 $wind redraw
		}
	} elseif {$args == "BradyBunch3x3"} {
		[$window_ window] resize 160 120
		place configure $w.top.vw -relx 0.0625 -rely 0.0625 -x 0 -y 0
		set as $active_($attached_src_)
		$as detach-window $window_
		$as attach-window $window_
		$window_ redraw
		after 1000 $window_ redraw
		
		foreach i {2 3 4 5 6 7 8 9} {
			set wind [set window${i}_]
			[$wind window] resize 160 120
			switch $i {
				2 {place configure $w.top.vw$i -relx 0.375 -rely 0.0625 \
						-x 0 -y 0}
				3 {place configure $w.top.vw$i -relx 0.6875 -rely 0.0625 \
						-x 0 -y 0}
				4 {place configure $w.top.vw$i -relx 0.0625 -rely 0.375 \
						-x 0 -y 0}
				5 {place configure $w.top.vw$i -relx 0.375 -rely 0.375 \
						-x 0 -y 0}
				6 {place configure $w.top.vw$i -relx 0.6875 -rely 0.375 \
						-x 0 -y 0}
				7 {place configure $w.top.vw$i -relx 0.0625 -rely 0.6875 \
						-x 0 -y 0}
				8 {place configure $w.top.vw$i -relx 0.375 -rely 0.6875 \
						-x 0 -y 0}
				9 {place configure $w.top.vw$i -relx 0.6875 -rely 0.6875 \
						-x 0 -y 0}
			}
			set as $active_([set attached_src${i}_])
			$as detach-window $wind
			$as attach-window $wind
			$wind redraw
			after 1000 $wind redraw
		}
	} elseif {$args == "PictureInPicture"} {
		# main videoWindow
		[$window_ window] resize 640 480
		place configure $w.top.vw -relx 0.0 -rely 0.0 -x 0 -y 0
		set as $active_($attached_src_)
		$as detach-window $window_
		$as attach-window $window_
		$window_ redraw
		after 1000 $window_ redraw
		# inside videoWindow
		set wind [set window2_]
		[$wind window] resize 168 128
		place configure $w.top.vw2 -relx 0.7 -rely 0.05 -x 0 -y 0
		raise $path_.top.vw2
		set as $active_([set attached_src2_])
		$as detach-window $wind
		$as attach-window $wind
		# XXX this should be a call to determine voff differently
		# for the win-in-win case(?)
		#[$wind window] voff 8
		$wind redraw
		after 1000 $wind redraw

		foreach i {3 4 5 6 7 8 9} {
			set wind [set window${i}_]
			[$wind window] resize 1 1
			set as $active_([set attached_src${i}_])
			$as detach-window $wind
			$as attach-window $wind
			$wind redraw
			after 1000 $wind redraw
		}
	} else {
		puts "Bad layout to reconfig to: $args"
		return
	}
	set currLayout_ $args
	after 3000 $window_ redraw
	#puts "main win sz: [[$window_ window] width]x[[$window_ window] height]" 
}


